<html>
<head>
<title>OgreGLHardwareOcclusionQuery.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7b8a29f58b064e3a63f570f2fc89729.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLHardwareOcclusionQuery.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLHardwareOcclusionQuery_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">/*</span>
<a name="l00030"></a>00030 <span class="comment">The nVidia occlusion query extension is defined in glext.h so you don&#39;t </span>
<a name="l00031"></a>00031 <span class="comment">need anything else. You do need to look up the function, we provide a </span>
<a name="l00032"></a>00032 <span class="comment">GLSupport class to do this, which has platform implementations for </span>
<a name="l00033"></a>00033 <span class="comment">getProcAddress. Check the way that extensions like glActiveTextureARB are </span>
<a name="l00034"></a>00034 <span class="comment">initialised and used in glRenderSystem and copy what is done there.</span>
<a name="l00035"></a>00035 <span class="comment"></span>
<a name="l00036"></a>00036 <span class="comment"></span>
<a name="l00037"></a>00037 <span class="comment"></span>
<a name="l00038"></a>00038 <span class="comment">  To do: fix so dx7 and DX9 checks and flags if HW Occlusion is supported</span>
<a name="l00039"></a>00039 <span class="comment">  See the openGl dito for ideas what to do.</span>
<a name="l00040"></a>00040 <span class="comment"></span>
<a name="l00041"></a>00041 <span class="comment">*/</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">//GL_ActiveTextureARB_Func* glActiveTextureARB_ptr = (GL_ActiveTextureARB_Func)mGLSupport-&gt;getProcAddress(&quot;glActiveTextureARB&quot;);</span>
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="preprocessor">#ifndef __GLHARDWAREOCCLUSIONQUERY_H__</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span><span class="preprocessor">#define __GLHARDWAREOCCLUSIONQUERY_H__</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span>
<a name="l00050"></a>00050 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLPrerequisites_8h.html">OgreGLPrerequisites.h</a>&quot;</span>
<a name="l00051"></a>00051 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareOcclusionQuery_8h.html">OgreHardwareOcclusionQuery.h</a>&quot;</span>
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="keyword">namespace </span>Ogre { 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 <span class="comment">// If you use multiple rendering passes you can test only the first pass and all other passes don&#39;t have to be rendered </span>
<a name="l00058"></a>00058 <span class="comment">// if the first pass result has too few pixels visible.</span>
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 <span class="comment">// Be sure to render all occluder first and whats out so the RenderQue don&#39;t switch places on </span>
<a name="l00061"></a>00061 <span class="comment">// the occluding objects and the tested objects because it thinks it&#39;s more effective..</span>
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00072"></a><a class="code" href="classOgre_1_1GLHardwareOcclusionQuery.html">00072</a> <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLHardwareOcclusionQuery.html" title="This is a class that is the base class of the query class for hardware occlusion.">GLHardwareOcclusionQuery</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwareOcclusionQuery.html" title="This is a abstract class that that provides the interface for the query class for hardware occlusion...">HardwareOcclusionQuery</a>
<a name="l00073"></a>00073 {
<a name="l00074"></a>00074 <span class="comment">//----------------------------------------------------------------------</span>
<a name="l00075"></a>00075 <span class="comment">// Public methods</span>
<a name="l00076"></a>00076 <span class="comment">//--</span>
<a name="l00077"></a>00077 <span class="keyword">public</span>:
<a name="l00082"></a>00082     <a class="code" href="classOgre_1_1GLHardwareOcclusionQuery.html" title="This is a class that is the base class of the query class for hardware occlusion.">GLHardwareOcclusionQuery</a>();
<a name="l00086"></a>00086     ~<a class="code" href="classOgre_1_1GLHardwareOcclusionQuery.html" title="This is a class that is the base class of the query class for hardware occlusion.">GLHardwareOcclusionQuery</a>();
<a name="l00087"></a>00087 
<a name="l00088"></a>00088     <span class="comment">//------------------------------------------------------------------</span>
<a name="l00089"></a>00089     <span class="comment">// Occlusion query functions (see base class documentation for this)</span>
<a name="l00090"></a>00090     <span class="comment">//--</span>
<a name="l00091"></a>00091     <span class="keywordtype">void</span> beginOcclusionQuery();
<a name="l00092"></a>00092     <span class="keywordtype">void</span> endOcclusionQuery();
<a name="l00093"></a>00093     <span class="keywordtype">bool</span> pullOcclusionQuery( <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>* NumOfFragments); 
<a name="l00094"></a>00094     <span class="keywordtype">bool</span> isStillOutstanding(<span class="keywordtype">void</span>);
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097     <span class="comment">//----------------------------------------------------------------------</span>
<a name="l00098"></a>00098     <span class="comment">// private members</span>
<a name="l00099"></a>00099     <span class="comment">//--</span>
<a name="l00100"></a>00100     <span class="keyword">private</span>:
<a name="l00101"></a>00101 
<a name="l00102"></a><a class="code" href="classOgre_1_1GLHardwareOcclusionQuery.html#a39b6663d049fe98e2bf30ae15a690cda">00102</a>         GLuint          <a class="code" href="classOgre_1_1GLHardwareOcclusionQuery.html#a39b6663d049fe98e2bf30ae15a690cda">mQueryID</a>;
<a name="l00103"></a>00103 };
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 }
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="preprocessor">#endif </span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
